import * as i0 from '@angular/core';
import { PLATFORM_ID, Component, ChangeDetectionStrategy, Inject, HostBinding, Input, NgModule } from '@angular/core';
import * as i2 from '@angular/common';
import { isPlatformBrowser, CommonModule } from '@angular/common';
import * as i1 from 'angular2-highlight-js';
import { HighlightJsService, HighlightJsModule } from 'angular2-highlight-js';
import { marked } from 'marked';

function CodeSnippetComponent_pre_1_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "pre")(1, "code");
        i0.ɵɵtext(2);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const ctx_r0 = i0.ɵɵnextContext();
        i0.ɵɵadvance(2);
        i0.ɵɵtextInterpolate(ctx_r0.codeSnippet);
    }
}
function CodeSnippetComponent_div_2_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelement(0, "div", 3);
    }
    if (rf & 2) {
        const ctx_r1 = i0.ɵɵnextContext();
        i0.ɵɵproperty("innerHTML", ctx_r1.codeSnippet, i0.ɵɵsanitizeHtml);
    }
}
class CodeSnippetComponent {
    constructor(platformId, el, highlightJsService) {
        this.platformId = platformId;
        this.el = el;
        this.highlightJsService = highlightJsService;
        this.setClass = true;
        this.processMarkdown = false;
        this.scrollable = true;
    }
    ngOnChanges() {
        if (this.processMarkdown) {
            this.codeSnippet = marked(this.codeSnippet);
        }
    }
    ngAfterViewInit() {
        if (isPlatformBrowser(this.platformId)) {
            const allPreEl = this.el.nativeElement.querySelectorAll('pre');
            for (const preElement of allPreEl) {
                if (!preElement.classList.contains('a-pre')) {
                    preElement.className += ' a-pre';
                    if (this.scrollable) {
                        preElement.className += ' a-pre--scrollable';
                    }
                }
                this.highlightJsService.highlight(preElement);
            }
        }
    }
}
/** @nocollapse */ CodeSnippetComponent.ɵfac = function CodeSnippetComponent_Factory(t) { return new (t || CodeSnippetComponent)(i0.ɵɵdirectiveInject(PLATFORM_ID), i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(i1.HighlightJsService)); };
/** @nocollapse */ CodeSnippetComponent.ɵcmp = /** @pureOrBreakMyCode */ i0.ɵɵdefineComponent({ type: CodeSnippetComponent, selectors: [["aui-code-snippet"]], hostVars: 2, hostBindings: function CodeSnippetComponent_HostBindings(rf, ctx) {
        if (rf & 2) {
            i0.ɵɵclassProp("ngx-code-snippet", ctx.setClass);
        }
    }, inputs: { codeSnippet: "codeSnippet", processMarkdown: "processMarkdown", scrollable: "scrollable" }, features: [i0.ɵɵNgOnChangesFeature], decls: 3, vars: 2, consts: [[1, "aui-code-snippet__inner"], [4, "ngIf"], ["class", "code-snippet-md", 3, "innerHTML", 4, "ngIf"], [1, "code-snippet-md", 3, "innerHTML"]], template: function CodeSnippetComponent_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "div", 0);
            i0.ɵɵtemplate(1, CodeSnippetComponent_pre_1_Template, 3, 1, "pre", 1);
            i0.ɵɵtemplate(2, CodeSnippetComponent_div_2_Template, 1, 1, "div", 2);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", !ctx.processMarkdown);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.processMarkdown);
        }
    }, dependencies: [i2.NgIf], encapsulation: 2, changeDetection: 0 });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(CodeSnippetComponent, [{
            type: Component,
            args: [{ selector: 'aui-code-snippet', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"aui-code-snippet__inner\">\n  <pre *ngIf=\"!this.processMarkdown\"><code>{{ codeSnippet }}</code></pre>\n\n  <div *ngIf=\"this.processMarkdown\" [innerHTML]=\"codeSnippet\" class=\"code-snippet-md\"></div>\n</div>\n" }]
        }], function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [PLATFORM_ID]
                    }] }, { type: i0.ElementRef }, { type: i1.HighlightJsService }];
    }, { setClass: [{
                type: HostBinding,
                args: ['class.ngx-code-snippet']
            }], codeSnippet: [{
                type: Input
            }], processMarkdown: [{
                type: Input
            }], scrollable: [{
                type: Input
            }] });
})();

class CodeSnippetModule {
}
/** @nocollapse */ CodeSnippetModule.ɵfac = function CodeSnippetModule_Factory(t) { return new (t || CodeSnippetModule)(); };
/** @nocollapse */ CodeSnippetModule.ɵmod = /** @pureOrBreakMyCode */ i0.ɵɵdefineNgModule({ type: CodeSnippetModule });
/** @nocollapse */ CodeSnippetModule.ɵinj = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjector({ providers: [
        HighlightJsService,
    ], imports: [CommonModule,
        HighlightJsModule] });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(CodeSnippetModule, [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        HighlightJsModule,
                    ],
                    declarations: [
                        CodeSnippetComponent,
                    ],
                    providers: [
                        HighlightJsService,
                    ],
                    exports: [
                        CodeSnippetComponent,
                    ],
                }]
        }], null, null);
})();
(function () {
    (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(CodeSnippetModule, { declarations: [CodeSnippetComponent], imports: [CommonModule,
            HighlightJsModule], exports: [CodeSnippetComponent] });
})();

/**
 * Generated bundle index. Do not edit.
 */

export { CodeSnippetComponent, CodeSnippetModule };
//# sourceMappingURL=acpaas-ui-ngx-code-snippet.mjs.map
